/**
 *
 */
package org.n52.sos.decode.json.inspire;

import org.n52.sos.inspire.aqd.Address;
import org.n52.sos.inspire.aqd.Contact;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;

public class ContactJSONDecoder extends AbstractJSONDecoder<Contact> {

    public ContactJSONDecoder() {
        super(Contact.class);
    }

    @Override
    public Contact decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        Contact contact = new Contact();
        contact.setAddress(decodeJsonToNillable(node
                                            .path(AQDJSONConstants.ADDRESS), Address.class));
        contact.setContactInstructions(parseNillableString(node
                .path(AQDJSONConstants.CONTACT_INSTRUCTIONS)));
        contact.setElectronicMailAddress(parseNillableString(node
                .path(AQDJSONConstants.ELECTRONIC_MAIL_ADDRESS)));
        contact.setHoursOfService(parseNillableString(node
                .path(AQDJSONConstants.HOURS_OF_SERVICE)));
        contact.setWebsite(parseNillableString(node
                .path(AQDJSONConstants.WEBSITE)));
        for (JsonNode n : node.path(AQDJSONConstants.TELEPHONE_FACSIMILE)) {
            contact.addTelephoneFacsimile(parseNillableString(n));
        }
        for (JsonNode n : node.path(AQDJSONConstants.TELEPHONE_VOICE)) {
            contact.addTelephoneVoice(parseNillableString(n));
        }
        return contact;
    }

}
