/**
 *
 */
package org.n52.sos.decode.json.inspire;

import org.n52.sos.inspire.aqd.EReportingChange;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;


public class EReportingChangeJSONDecoder extends AbstractJSONDecoder<EReportingChange> {

    public EReportingChangeJSONDecoder() {
        super(EReportingChange.class);
    }

    @Override
    public EReportingChange decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        boolean changed = node.path(AQDJSONConstants.CHANGED).asBoolean();
        String description = node.path(AQDJSONConstants.DESCRIPTION).textValue();
        return new EReportingChange(changed, description);
    }

}
