/**
 *
 */
package org.n52.sos.decode.json.inspire;

import org.n52.sos.inspire.aqd.EReportingChange;
import org.n52.sos.inspire.aqd.EReportingHeader;
import org.n52.sos.inspire.aqd.InspireID;
import org.n52.sos.inspire.aqd.RelatedParty;
import org.n52.sos.ogc.gml.AbstractFeature;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;

public class EReportingHeaderJSONDecoder extends AbstractJSONDecoder<EReportingHeader> {

    public EReportingHeaderJSONDecoder() {
        super(EReportingHeader.class);
    }

    @Override
    public EReportingHeader decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        EReportingHeader header = new EReportingHeader();
        header.setChange(decodeJsonToObject(node.path(AQDJSONConstants.CHANGE), EReportingChange.class));
        header.setInspireID(decodeJsonToObject(node.path(AQDJSONConstants.INSPIRE_ID), InspireID.class));
        header.setReportingAuthority(decodeJsonToObject(node.path(AQDJSONConstants.REPORTING_AUTHORITY), RelatedParty.class));
        header.setReportingPeriod(parseReferenceableTime(node.path(AQDJSONConstants.REPORTING_PERIOD)));
        for (JsonNode child : node.path(AQDJSONConstants.CONTENT)) {
            header.addContent(decodeJsonToReferencable(child, AbstractFeature.class));
        }
        for (JsonNode child : node.path(AQDJSONConstants.DELETE)) {
            header.addDelete(decodeJsonToReferencable(child, AbstractFeature.class));
        }
        return header;
    }

}
