/**
 *
 */
package org.n52.sos.decode.json.inspire;

import org.n52.sos.inspire.aqd.GeographicalName;
import org.n52.sos.inspire.aqd.Pronunciation;
import org.n52.sos.inspire.aqd.Spelling;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fasterxml.jackson.databind.JsonNode;


public class GeographicalNameJSONDecoder  extends AbstractJSONDecoder<GeographicalName>{

    private static final Logger log = LoggerFactory.getLogger(GeographicalNameJSONDecoder.class);

    public GeographicalNameJSONDecoder() {
        super(GeographicalName.class);
    }

    @Override
    public GeographicalName decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        GeographicalName geographicalName = new GeographicalName();
        geographicalName.setGrammaticalGender(parseNillableCodeType(node
                .path(AQDJSONConstants.GRAMMATICAL_GENDER)));
        geographicalName.setGrammaticalNumber(parseNillableCodeType(node
                .path(AQDJSONConstants.GRAMMATICAL_NUMBER)));
        geographicalName.setLanguage(parseNillableString(node
                .path(AQDJSONConstants.LANGUAGE)));
        geographicalName.setNameStatus(parseNillableCodeType(node
                .path(AQDJSONConstants.NAME_STATUS)));
        geographicalName.setNativeness(parseNillableCodeType(node
                .path(AQDJSONConstants.NATIVENESS)));
        geographicalName.setSourceOfName(parseNillableString(node
                .path(AQDJSONConstants.SOURCE_OF_NAME)));
        geographicalName.setPronunciation(decodeJsonToNillable(node
                .path(AQDJSONConstants.PRONUNCIATION), Pronunciation.class));
        for (JsonNode n : node.path(AQDJSONConstants.SPELLING)) {
            geographicalName.addSpelling(decodeJsonToObject(n, Spelling.class));
        }
        return geographicalName;
    }
}
