/**
 *
 */
package org.n52.sos.decode.json.inspire;


import org.n52.sos.inspire.aqd.Contact;
import org.n52.sos.inspire.aqd.RelatedParty;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;

public class RelatedPartyJSONDecoder extends AbstractJSONDecoder<RelatedParty> {

    public RelatedPartyJSONDecoder() {
        super(RelatedParty.class);
    }

    @Override
    public RelatedParty decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        RelatedParty relatedParty = new RelatedParty();
        relatedParty.setContact(decodeJsonToNillable(node
                .path(AQDJSONConstants.CONTACT), Contact.class));
        relatedParty.setIndividualName(parseNillableString(node
                .path(AQDJSONConstants.INDIVIDUAL_NAME)));
        relatedParty.setOrganisationName(parseNillableString(node
                .path(AQDJSONConstants.ORGANISATION_NAME)));
        relatedParty.setPositionName(parseNillableString(node
                .path(AQDJSONConstants.POSITION_NAME)));
        for (JsonNode n : node.path(AQDJSONConstants.ROLES)) {
            relatedParty.addRole(parseNillableReference(n));
        }
        return relatedParty;
    }

}