/**
 *
 */
package org.n52.sos.decode.json.inspire;

import org.n52.sos.inspire.aqd.EReportingChange;
import org.n52.sos.inspire.aqd.InspireID;
import org.n52.sos.inspire.aqd.ReportObligation;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;


public class ReportObligationJSONDecoder extends AbstractJSONDecoder<ReportObligation> {

    public ReportObligationJSONDecoder() {
        super(ReportObligation.class);
    }

    @Override
    public ReportObligation decodeJSON(JsonNode node, boolean validate)
            throws OwsExceptionReport {
        ReportObligation reportObligation = new ReportObligation();
        reportObligation.setChange(decodeJsonToObject(node.path(AQDJSONConstants.CHANGE), EReportingChange.class));
        reportObligation.setInspireID(decodeJsonToObject(node.path(AQDJSONConstants.INSPIRE_ID), InspireID.class));
        reportObligation.setReportingPeriod(parseReferenceableTime(node.path(AQDJSONConstants.REPORTING_PERIOD)));
        return reportObligation;
    }

}
