/**
 *
 */
package org.n52.sos.decode.xml.stream;

import java.util.LinkedList;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.ogc.ows.OwsExceptionReport;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public abstract class ListReader<T> extends XmlReader<List<T>> {
    private XmlReader<T> delegate;
    private List<T> list;

    protected abstract XmlReader<T> getMemberDelegate();

    protected abstract QName getMemberName();

    @Override
    protected void begin()
            throws XMLStreamException, OwsExceptionReport {
        this.delegate = getMemberDelegate();
        this.list = new LinkedList<>();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(getMemberName())) {
            list.add(delegate(this.delegate));
        } else {
            ignore();
        }
    }

    @Override
    protected List<T> finish() {
        return list;
    }

}
