/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.ad;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.decode.xml.stream.w3c.xlink.NillableReferenceReader;
import org.n52.sos.inspire.aqd.Address;
import org.n52.sos.ogc.ows.OwsExceptionReport;

public class AddressRepresentationReader extends XmlReader<Address> {
    private Address address;

    @Override
    protected void begin()
            throws XMLStreamException, OwsExceptionReport {
        this.address = new Address();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_AD_ADMIN_UNIT)) {
            address.addAdminUnit(delegate(new AdminUnitReader()));
        } else if (name.equals(AqdConstants.QN_AD_LOCATOR_DESIGNATOR)) {
            address.addLocatorDesignator(chars());
        } else if (name.equals(AqdConstants.QN_AD_LOCATOR_NAME)) {
            address.addLocatorName(delegate(new LocatorNameReader()));
        } else if (name.equals(AqdConstants.QN_AD_ADDRESS_AREA)) {
            address.addAddressArea(delegate(new AddressAreaReader()));
        } else if (name.equals(AqdConstants.QN_AD_POST_NAME)) {
            address.addPostName(delegate(new PostNameReader()));
        } else if (name.equals(AqdConstants.QN_AD_POST_CODE)) {
            address.setPostCode(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_AD_THOROUGHFARE)) {
            address.addThoroughfare(delegate(new ThoroughfareReader()));
        } else if (name.equals(AqdConstants.QN_AD_ADDRESS_FEATURE)) {
            address.setAddressFeature(delegate(new NillableReferenceReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected Address finish()
            throws OwsExceptionReport {
        return this.address;
    }

}
