/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.aqd;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.inspire.aqd.InspireID;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.Nillable;

/**
 * TODO JavaDoc
 * @author Christian Autermann
 */
public class InpireIDReader extends XmlReader<InspireID> {

    private InspireID inspireID;

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_BASE_IDENTIFIER)) {
        } else if (name.equals(AqdConstants.QN_BASE_LOCAL_ID)) {
            this.inspireID.setLocalId(chars());
        } else if (name.equals(AqdConstants.QN_BASE_NAMESPACE)) {
            this.inspireID.setNamespace(chars());
        } else if (name.equals(AqdConstants.QN_BASE_VERSION_ID)) {
            this.inspireID.setVersionId(delegate(new NillableStringReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected void begin() {
        this.inspireID = new InspireID().setVersionId(Nillable.<String>absent());
    }

    @Override
    protected InspireID finish()
            throws OwsExceptionReport {
        return this.inspireID;
    }

}
