/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.aqd;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.decode.xml.stream.w3c.xlink.ReferenceableFeatureReader;
import org.n52.sos.inspire.aqd.EReportingChange;
import org.n52.sos.inspire.aqd.EReportingHeader;
import org.n52.sos.ogc.ows.OwsExceptionReport;

public class ReportingHeaderReader extends XmlReader<EReportingHeader> {

    private EReportingHeader header;
    private boolean change = false;
    private String changeDescription;

    @Override
    protected void begin() {
        this.header = new EReportingHeader();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_AQD_INSPIRE_ID)) {
            this.header.setInspireID(delegate(new InpireIDReader()));
        } else if (name.equals(AqdConstants.QN_AQD_REPORTING_AUTHORITY)) {
            this.header
                    .setReportingAuthority(delegate(new ReportingAuthorityReader()));
        } else if (name.equals(AqdConstants.QN_AQD_REPORTING_PERIOD)) {
            this.header
                    .setReportingPeriod(delegate(new ReportingPeriodReader()));
        } else if (name.equals(AqdConstants.QN_AQD_CONTENT)) {
            this.header.addContent(delegate(new ReferenceableFeatureReader()));
        } else if (name.equals(AqdConstants.QN_AQD_DELETE)) {
            this.header.addDelete(delegate(new ReferenceableFeatureReader()));
        } else if (name.equals(AqdConstants.QN_AQD_CHANGE)) {
            this.change = Boolean.valueOf(chars());
        } else if (name.equals(AqdConstants.QN_AQD_CHANGE_DESCRIPTION)) {
            this.changeDescription = chars();
        } else {
            ignore();
        }
    }

    @Override
    protected EReportingHeader finish()
            throws OwsExceptionReport {
        return this.header
                .setChange(new EReportingChange(change, changeDescription));
    }

}
