/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.base2;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.decode.xml.stream.inspire.gco.NillableFreeTextReader;
import org.n52.sos.inspire.aqd.Contact;
import org.n52.sos.ogc.ows.OwsExceptionReport;

public class ContactReader extends XmlReader<Contact> {

    private Contact contact;

    @Override
    protected void begin()
            throws XMLStreamException, OwsExceptionReport {
        this.contact = new Contact();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_BASE2_ADDRESS)) {
            this.contact.setAddress(delegate(new AddressReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_CONTACT_INSTRUCTIONS)) {
            this.contact
                    .setContactInstructions(delegate(new NillableFreeTextReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_ELECTRONIC_MAIL_ADDRESS)) {
            this.contact
                    .setElectronicMailAddress(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_HOURS_OF_SERVICE)) {
            this.contact
                    .setHoursOfService(delegate(new NillableFreeTextReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_WEBSITE)) {
            this.contact.setWebsite(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_TELEPHONE_FACSIMILE)) {
            this.contact
                    .addTelephoneFacsimile(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_TELEPHONE_VOICE)) {
            this.contact.addTelephoneVoice(delegate(new NillableStringReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected Contact finish()
            throws OwsExceptionReport {
        return contact;
    }

}
