/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.base2;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.decode.xml.stream.inspire.gco.NillableFreeTextReader;
import org.n52.sos.decode.xml.stream.w3c.xlink.NillableReferenceReader;
import org.n52.sos.inspire.aqd.RelatedParty;
import org.n52.sos.ogc.ows.OwsExceptionReport;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class RelatedPartyReader extends XmlReader<RelatedParty> {

    private RelatedParty relatedParty;

    @Override
    protected void begin() {
        this.relatedParty = new RelatedParty();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_BASE2_INDIVIDUAL_NAME)) {
            this.relatedParty
                    .setIndividualName(delegate(new NillableFreeTextReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_ORGANISATION_NAME)) {
            this.relatedParty
                    .setOrganisationName(delegate(new NillableFreeTextReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_POSITION_NAME)) {
            this.relatedParty
                    .setPositionName(delegate(new NillableFreeTextReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_CONTACT)) {
            this.relatedParty.setContact(delegate(new NillableContactReader()));
        } else if (name.equals(AqdConstants.QN_BASE2_ROLE)) {
            this.relatedParty.addRole(delegate(new NillableReferenceReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected RelatedParty finish()
            throws OwsExceptionReport {
        return this.relatedParty;
    }

}
