/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.gn;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.decode.xml.stream.ogc.ows.NillableCodeTypeReader;
import org.n52.sos.inspire.aqd.GeographicalName;
import org.n52.sos.ogc.ows.OwsExceptionReport;

public class GeographicalNameReader extends XmlReader<GeographicalName> {
    private GeographicalName geographicalName;

    @Override
    protected void begin() {
        this.geographicalName = new GeographicalName();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_GN_LANGUAGE)) {
            this.geographicalName.setLanguage(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_GN_NATIVENESS)) {
            this.geographicalName.setNativeness(delegate(new NillableCodeTypeReader()));
        } else if (name.equals(AqdConstants.QN_GN_NAME_STATUS)) {
            this.geographicalName.setNameStatus(delegate(new NillableCodeTypeReader()));
        } else if (name.equals(AqdConstants.QN_GN_SOURCE_OF_NAME)) {
            this.geographicalName.setSourceOfName(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_GN_PRONUNCIATION)) {
            this.geographicalName.setPronunciation(delegate(new PronounciationReader()));
        } else if (name.equals(AqdConstants.QN_GN_SPELLING)) {
            this.geographicalName.addSpelling(delegate(new SpellingReader()));
        } else if (name.equals(AqdConstants.QN_GN_GRAMMATICAL_GENDER)) {
            this.geographicalName.setGrammaticalGender(delegate(new NillableCodeTypeReader()));
        } else if (name.equals(AqdConstants.QN_GN_GRAMMATICAL_NUMBER)) {
            this.geographicalName.setGrammaticalNumber(delegate(new NillableCodeTypeReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected GeographicalName finish() {
        return this.geographicalName;
    }



}
