/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.gn;

import java.net.URI;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.inspire.aqd.Pronunciation;
import org.n52.sos.ogc.ows.OwsExceptionReport;

import com.google.common.base.Function;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class PronunciationOfNameReader extends XmlReader<Pronunciation> {
    private static final Function<String, URI> STRING_TO_URI
            = new Function<String, URI>() {
                @Override
                public URI apply(String input) {
                    return URI.create(input);
                }
            };
    private Pronunciation pronunciation;

    @Override
    protected void begin() {
        this.pronunciation = new Pronunciation();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_GN_PRONUNCIATION_SOUND_LINK)) {
            this.pronunciation.setSoundLink(delegate(new NillableStringReader()).transform(STRING_TO_URI));
        } else if (name.equals(AqdConstants.QN_GN_PRONUNCIATION_IPA)) {
            this.pronunciation.setIPA(delegate(new NillableStringReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected Pronunciation finish() {
        return this.pronunciation;
    }

}
