/**
 *
 */
package org.n52.sos.decode.xml.stream.inspire.gn;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.aqd.AqdConstants;
import org.n52.sos.decode.xml.stream.NillableStringReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.inspire.aqd.Spelling;
import org.n52.sos.ogc.ows.OwsExceptionReport;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class SpellingOfNameReader extends XmlReader<Spelling> {
    private Spelling spelling;

    @Override
    protected void begin() {
        this.spelling = new Spelling();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(AqdConstants.QN_GN_TEXT)) {
            this.spelling.setText(chars());
        } else if (name.equals(AqdConstants.QN_GN_SCRIPT)) {
            this.spelling.setScript(delegate(new NillableStringReader()));
        } else if (name.equals(AqdConstants.QN_GN_TRANSLITERATION_SCHEME)) {
            this.spelling.setTransliterationScheme(delegate(new NillableStringReader()));
        } else {
            ignore();
        }
    }

    @Override
    protected Spelling finish() {
        return this.spelling;
    }

}
