/**
 *
 */
package org.n52.sos.decode.xml.stream.ogc.gml;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.ogc.gml.GmlConstants;
import org.n52.sos.ogc.gml.time.TimeInstant;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.DateTimeHelper;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class TimeInstantReader extends XmlReader<TimeInstant> {

    private TimeInstant time;

    @Override
    protected void begin()
            throws XMLStreamException, OwsExceptionReport {
        this.time = new TimeInstant();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(GmlConstants.QN_TIME_POSITION_32)) {
            time.setValue(DateTimeHelper.parseIsoString2DateTime(chars()));
        } else {
            ignore();
        }
    }

    @Override
    protected TimeInstant finish()
            throws OwsExceptionReport {
        return this.time;
    }

}
