/**
 *
 */
package org.n52.sos.decode.xml.stream.ogc.gml;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.ogc.gml.GmlConstants;
import org.n52.sos.ogc.gml.time.TimePeriod;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.DateTimeHelper;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class TimePeriodReader extends XmlReader<TimePeriod> {

    private TimePeriod time;

    @Override
    protected void begin() {
        this.time = new TimePeriod();
    }

    @Override
    protected void read(QName name)
            throws XMLStreamException, OwsExceptionReport {
        if (name.equals(GmlConstants.QN_END_POSITION_32)) {
            time.setEnd(DateTimeHelper.parseIsoString2DateTime(chars()));
        } else if (name.equals(GmlConstants.QN_BEGIN_POSITION_32)) {
            time.setStart(DateTimeHelper.parseIsoString2DateTime(chars()));
        } else {
            ignore();
        }
    }

    @Override
    protected TimePeriod finish() {
        return this.time;
    }

}
