/**
 *
 */
package org.n52.sos.decode.xml.stream.w3c.xlink;

import java.net.URI;

import javax.xml.stream.XMLStreamException;

import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.Reference;
import org.n52.sos.w3c.W3CConstants;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class ReferenceReader extends XmlReader<Reference> {

    private Reference reference;

    @Override
    protected void begin()
            throws XMLStreamException, OwsExceptionReport {
        this.reference = parseReference();
    }

    protected Reference parseReference() {
        Reference ref = new Reference();
        ref.setHref(URI.create(attr(W3CConstants.QN_XLINK_HREF).get()));
        ref.setActuate(attr(W3CConstants.QN_XLINK_ACTUATE).orNull());
        ref.setArcrole(attr(W3CConstants.QN_XLINK_ARCROLE).orNull());
        ref.setRole(attr(W3CConstants.QN_XLINK_ROLE).orNull());
        ref.setShow(attr(W3CConstants.QN_XLINK_SHOW).orNull());
        ref.setTitle(attr(W3CConstants.QN_XLINK_TITLE).orNull());
        ref.setType(attr(W3CConstants.QN_XLINK_TYPE).orNull());
        return ref;
    }

    @Override
    protected Reference finish() {
        return reference;
    }

}
