/**
 *
 */
package org.n52.sos.decode.xml.stream.w3c.xlink;

import javax.xml.stream.XMLStreamException;

import org.n52.sos.decode.xml.stream.NillableReader;
import org.n52.sos.decode.xml.stream.XmlReader;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.Referenceable;
import org.n52.sos.w3c.W3CConstants;

public abstract class ReferenceableReader<T> extends XmlReader<Referenceable<T>> {

    private Referenceable<T> referenceable;

    @Override
    protected void begin() throws XMLStreamException, OwsExceptionReport {
        if (attr(W3CConstants.QN_XLINK_HREF).isPresent()) {
            this.referenceable = Referenceable.of(delegate(new ReferenceReader()));
        } else {
            this.referenceable = Referenceable.of(delegate(new NillableReaderImpl()));
        }
    }

    @Override
    protected Referenceable<T> finish()
            throws OwsExceptionReport {
        return referenceable;
    }

    protected abstract XmlReader<T> getDelegate();

    private class NillableReaderImpl extends NillableReader<T> {
        @Override
        protected XmlReader<T> getDelegate() {
            return ReferenceableReader.this.getDelegate();
        }
    }

}
