/**
 *
 */
package org.n52.sos.encode.json.inspire;

import org.n52.sos.encode.json.JSONEncoder;
import org.n52.sos.inspire.aqd.Address;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class AddressJSONEncoder extends JSONEncoder<Address> {

    public AddressJSONEncoder() {
        super(Address.class);
    }

    @Override
    public JsonNode encodeJSON(Address t)
            throws OwsExceptionReport {
        ObjectNode j = nodeFactory().objectNode();
        j.put(AQDJSONConstants.ADDRESS_AREAS, encodeObjectToJson(t.getAddressAreas()));
        j.put(AQDJSONConstants.ADDRESS_FEATURE, encodeObjectToJson(t.getAddressFeature()));
        j.put(AQDJSONConstants.ADMIN_UNITS, encodeObjectToJson(t.getAdminUnits()));
        j.put(AQDJSONConstants.LOCATOR_DESIGNATORS, encodeObjectToJson(t.getLocatorDesignators()));
        j.put(AQDJSONConstants.LOCATOR_NAMES, encodeObjectToJson(t.getLocatorNames()));
        j.put(AQDJSONConstants.POST_CODE, encodeObjectToJson(t.getPostCode()));
        j.put(AQDJSONConstants.POST_NAMES, encodeObjectToJson(t.getPostNames()));
        j.put(AQDJSONConstants.THOROUGHFARES, encodeObjectToJson(t.getThoroughfares()));
        return j;
    }

}
