/**
 *
 */
package org.n52.sos.encode.json.inspire;

import org.n52.sos.encode.json.JSONEncoder;
import org.n52.sos.ogc.ows.OwsExceptionReport;
import org.n52.sos.util.AQDJSONConstants;
import org.n52.sos.util.Nillable;

import com.fasterxml.jackson.databind.JsonNode;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class NillableJSONEncoder extends JSONEncoder<Nillable<?>> {

    public NillableJSONEncoder() {
        super(Nillable.class);
    }

    @Override
    public JsonNode encodeJSON(Nillable<?> t)
            throws OwsExceptionReport {
        if (t.isAbsent()) {
            return nodeFactory().nullNode();
        } else if (t.isNil()) {
            return nodeFactory().objectNode()
                    .put(AQDJSONConstants.NIL, true)
                    .put(AQDJSONConstants.REASON, t.getNilReason().orNull());
        } else {
            return encodeObjectToJson(t.get());
        }
    }

}
