/**
 *
 */
package org.n52.sos.inspire.aqd;

import com.google.common.base.Objects;
import com.google.common.base.Optional;

public class EReportingChange {
    private boolean changed;
    private Optional<String> description;

    public EReportingChange(String description) {
        this(true, description);
    }

    public EReportingChange() {
        this(false, null);
    }

    public EReportingChange(boolean changed) {
        this(changed, null);
    }

    public EReportingChange(boolean changed, String description) {
        this.changed = changed;
        this.description = Optional.fromNullable(description);
    }

    public boolean isChange() {
        return this.changed;
    }

    public Optional<String> getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = Optional.fromNullable(description);
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getDescription());
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof EReportingChange && Objects
               .equal(getDescription(), ((EReportingChange) obj)
                      .getDescription());
    }

    @Override
    public String toString() {
        return Objects.toStringHelper(this)
                .add("change", isChange())
                .add("description", getDescription())
                .toString();
    }

}
