/**
 *
 */
package org.n52.sos.inspire.aqd;

import org.n52.sos.util.Nillable;

import com.google.common.base.Objects;
import com.google.common.base.Preconditions;

public class InspireID {

    private String namespace;
    private String localId;
    private Nillable<String> versionId = Nillable.absent();

    public String getNamespace() {
        return namespace;
    }

    public InspireID setNamespace(String namespace) {
        this.namespace = Preconditions.checkNotNull(namespace);
        return this;
    }

    public String getLocalId() {
        return localId;
    }

    public InspireID setLocalId(String localId) {
        this.localId = Preconditions.checkNotNull(localId);
        return this;
    }

    public Nillable<String> getVersionId() {
        return versionId;
    }

    public void setVersionId(String versionId) {
        this.versionId = Nillable.of(versionId);
    }

    public InspireID setVersionId(Nillable<String> versionId) {
        this.versionId = versionId;
        return this;
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getNamespace(), getLocalId(), getVersionId());
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof InspireID) {
            InspireID that = (InspireID) obj;
            return Objects.equal(this.getNamespace(), that.getNamespace()) &&
                   Objects.equal(this.getLocalId(), that.getLocalId()) &&
                   Objects.equal(this.getVersionId(), that.getVersionId());
        }
        return false;
    }

    @Override
    public String toString() {
        return Objects.toStringHelper(this)
                .add("localId", getLocalId())
                .add("namespace", getNamespace())
                .add("versionId", getVersionId())
                .toString();
    }
}
