/**
 *
 */
package org.n52.sos.inspire.aqd;

import java.net.URI;

import org.n52.sos.util.Nillable;

import com.google.common.base.Objects;
import com.google.common.base.Preconditions;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class Pronunciation {

    private Nillable<String> ipa = Nillable.missing();
    private Nillable<URI> soundLink = Nillable.missing();

    public Nillable<String> getIPA() {
        return ipa;
    }

    public Pronunciation setIPA(Nillable<String> ipa) {
        this.ipa = Preconditions.checkNotNull(ipa);
        return this;
    }

    public Pronunciation setIPA(String ipa) {
        return setIPA(Nillable.of(ipa));
    }

    public Nillable<URI> getSoundLink() {
        return soundLink;
    }

    public Pronunciation setSoundLink(Nillable<URI> soundLink) {
        this.soundLink = Preconditions.checkNotNull(soundLink);
        return this;
    }

    public Pronunciation setSoundLink(URI soundLink) {
        return setSoundLink(Nillable.of(soundLink));
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getIPA(), getSoundLink());
    }

    @Override
    public String toString() {
        return Objects.toStringHelper(this)
                .add("ipa", getIPA())
                .add("soundLink", getSoundLink())
                .toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Pronunciation) {
            Pronunciation that = (Pronunciation) obj;
            return Objects.equal(this.getIPA(), that.getIPA()) &&
                   Objects.equal(this.getSoundLink(), that.getSoundLink());
        }
        return false;
    }

}
