/**
 *
 */
package org.n52.sos.inspire.aqd;

import org.n52.sos.ogc.gml.time.Time;
import org.n52.sos.util.Nillable;
import org.n52.sos.util.Referenceable;

import com.google.common.base.Objects;
import com.google.common.base.Preconditions;

/**
 * TODO JavaDoc
 *
 * @author Christian Autermann
 */
public class ReportObligation {
    private InspireID inspireID;
    private EReportingChange change;
    private Referenceable<Time> reportingPeriod
            = Referenceable.of(Nillable.<Time>missing());

    public EReportingChange getChange() {
        return change;
    }

    public ReportObligation setChange(EReportingChange change) {
        this.change = Preconditions.checkNotNull(change);
        return this;
    }

    public boolean isSetChange() {
		return getChange() != null;
	}

	public InspireID getInspireID() {
        return inspireID;
    }

    public ReportObligation setInspireID(InspireID inspireID) {
        this.inspireID = Preconditions.checkNotNull(inspireID);
        return this;
    }

    public boolean isSetInspireID() {
		return getInspireID() != null;
	}

	public Referenceable<Time> getReportingPeriod() {
        return reportingPeriod;
    }

    public ReportObligation setReportingPeriod(
            Referenceable<Time> reportingPeriod) {
        this.reportingPeriod = Preconditions.checkNotNull(reportingPeriod);
        return this;
    }
    
    public boolean isValid() {
    	return isSetInspireID() && isSetChange(); 
    }

    @Override
    public int hashCode() {
        return Objects
                .hashCode(getInspireID(), getChange(), getReportingPeriod());
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof ReportObligation) {
            ReportObligation that = (ReportObligation) obj;
            return Objects.equal(getInspireID(), that.getInspireID()) &&
                   Objects.equal(getChange(), that.getChange()) &&
                   Objects.equal(getReportingPeriod(), that.getReportingPeriod());
        }
        return false;
    }

    @Override
    public String toString() {
        return Objects.toStringHelper(this)
                .add("inspireID", getInspireID())
                .add("change", getChange())
                .add("reportingPeriod", getReportingPeriod())
                .toString();
    }
}
