/**
 *
 */
package org.n52.sos.inspire.aqd;


import org.n52.sos.util.Nillable;

import com.google.common.base.Objects;
import com.google.common.base.Preconditions;
import com.google.common.base.Strings;

/**
 * TODO JavaDoc
 * @author Christian Autermann
 */
public class Spelling {

    private String text;
    private Nillable<String> script = Nillable.missing();
    private Nillable<String> transliterationScheme = Nillable.missing();

    public String getText() {
        if (Strings.isNullOrEmpty(text)) {
            return "unknown";
        }
        return text;
    }

    public Spelling setText(String text) {
        this.text = Preconditions.checkNotNull(text);
        return this;
    }

    public Nillable<String> getScript() {
        return script;
    }

    public Spelling setScript(Nillable<String> script) {
        this.script = Preconditions.checkNotNull(script);
        return this;
    }

    public Spelling setScript(String script) {
        return setScript(Nillable.of(script));
    }

    public Nillable<String> getTransliterationScheme() {
        return transliterationScheme;
    }

    public Spelling setTransliterationScheme(Nillable<String> transliterationScheme) {
        this.transliterationScheme = Preconditions.checkNotNull(transliterationScheme);
        return this;
    }

    public Spelling setTransliterationScheme(String transliterationScheme) {
        return this.setTransliterationScheme(Nillable.of(transliterationScheme));
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getText(), getScript(), getTransliterationScheme());
    }

    @Override
    public String toString() {
        return Objects.toStringHelper(this)
                .add("text", getText())
                .add("script", getScript())
                .add("transliterationScheme", getTransliterationScheme())
                .toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Spelling) {
            Spelling that = (Spelling) obj;
            return Objects.equal(this.getText(), that.getText()) &&
                   Objects.equal(this.getScript(), that.getScript()) &&
                   Objects.equal(this.getTransliterationScheme(), that.getTransliterationScheme());
        }
        return false;
    }





}
